#ifndef __ShoutPlayer_h
#define __ShoutPlayer_h

class ShoutPlayer {
private:
	struct Privates;
	Privates *privates;
	int get_buffer_length() const;
	void add_next_in_buffer();
	void wimData(HWAVEOUT hwo, DWORD_PTR dwParam1, DWORD_PTR dwParam2);
	static void CALLBACK waveProc(HWAVEOUT hwo, UINT uMsg, DWORD_PTR dwInstance, DWORD_PTR dwParam1, DWORD_PTR dwParam2);
	void clear_buffer();
public:
	ShoutPlayer();
	~ShoutPlayer();
	bool Open(int index);
	bool Start();
	void Stop();
	void Close();
	void SetServerInfo(std::string const &host, int port, std::string const &password);
	bool ConnectServer();
	bool ServerConnected() const;
};


#endif
